% Copyright (c) 2020 
% Authors:
% F. Pierre, M. Amendola, C. Bigeard, T. Ruel
% and P.-F. Villard
% 
% This program is free software: you can redistribute it and/or 
% modify it under the terms of the GNU Affero General Public 
% License as published by the Free Software Foundation, either 
% version 3 of the License, or (at your option) any later 
% version.
% 
% This program is distributed in the hope that it will be 
% useful, but WITHOUT ANY WARRANTY; without even the implied 
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
% PURPOSE. See the GNU Affero General Public License for more 
% details.
% 
% You should have received a copy of the GNU Affero General 
% Public License along with this program. If not, 
% see <http://www.gnu.org/licenses/>.

function [B] = balloonForce(V)
% Computes the set of normal vectors in each coordinate of the snake.

n=size(V,1);

% Normal operator for polygon.
A = diag(ones(n-1, 1), 1) - diag(ones(n-1, 1), -1);
A(n, 1) = 1; A(1, n) = -1;

% operator application. 
B = A * V * [0, -1; 1, 0];

%  Normalization of normal vectors. 
normb = sqrt(sum(B.^2, 2));
B = B ./ (normb * [1,1]);% Equation (22) in the paper
