% Copyright (c) 2020 
% Authors:
% F. Pierre, M. Amendola, C. Bigeard, T. Ruel
% and P.-F. Villard
% 
% This program is free software: you can redistribute it and/or 
% modify it under the terms of the GNU Affero General Public 
% License as published by the Free Software Foundation, either 
% version 3 of the License, or (at your option) any later 
% version.
% 
% This program is distributed in the hope that it will be 
% useful, but WITHOUT ANY WARRANTY; without even the implied 
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
% PURPOSE. See the GNU Affero General Public License for more 
% details.
% 
% You should have received a copy of the GNU Affero General 
% Public License along with this program. If not, 
% see <http://www.gnu.org/licenses/>.


function G = gradientCentred( I )
% Computes the gradient of I with a centered scheme and 
% symetrical boundary conditions. 


% Initialization
G=zeros(size(I,1), size(I,2), 2);
G(2:end-1,:,1) = 0.5*(I(3:end,:)-I(1:end-2,:));
G(:,2:end-1,2) = 0.5*(I(:,3:end)-I(:,1:end-2));
% Equation (25) of the paper
G(1,:,1)=0.5*(I(2,:)-I(1,:));
G(end,:,1)=0.5*(I(end,:)-I(end-1,:));
% Equation (26) of the paper
G(:,1,2)=0.5*(I(:,2)-I(:,1));
G(:,end,2)=0.5*(I(:,end)-I(:,end-1));

end

