% Copyright (c) 2020 
% Authors:
% F. Pierre, M. Amendola, C. Bigeard, T. Ruel
% and P.-F. Villard
% 
% This program is free software: you can redistribute it and/or 
% modify it under the terms of the GNU Affero General Public 
% License as published by the Free Software Foundation, either 
% version 3 of the License, or (at your option) any later 
% version.
% 
% This program is distributed in the hope that it will be 
% useful, but WITHOUT ANY WARRANTY; without even the implied 
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
% PURPOSE. See the GNU Affero General Public License for more 
% details.
% 
% You should have received a copy of the GNU Affero General 
% Public License along with this program. If not, 
% see <http://www.gnu.org/licenses/>.


%Select initialization points
function V=selectPoints(I)
%
% 
% I: image
% [x,y]: selected coordinates
%
% Selects positions manually on the image I
% Left click to select a position
% Right click to stop
% 
%
colormap(gray);
x=[];
y=[];
disp('Left click to select a position');
disp('Right click to stop');
but = 1;
while but == 1
	clf
	imshow(uint8(I))
	grid on;
	hold on
	plot(x, y, 'r-','linewidth',3);
	plot(x, y, 'b+','linewidth',3);
	axis off image
	[s, t, but] = ginput(1);
	x = [x;s];
	y = [y;t];
end
close;
V=[x(:),y(:)];

if polygonParity(V) ~= 1
    V=V(end:-1:1, :);
end
