% Copyright (c) 2020 
% Authors:
% F. Pierre, M. Amendola, C. Bigeard, T. Ruel
% and P.-F. Villard
% 
% This program is free software: you can redistribute it and/or 
% modify it under the terms of the GNU Affero General Public 
% License as published by the Free Software Foundation, either 
% version 3 of the License, or (at your option) any later 
% version.
% 
% This program is distributed in the hope that it will be 
% useful, but WITHOUT ANY WARRANTY; without even the implied 
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
% PURPOSE. See the GNU Affero General Public License for more 
% details.
% 
% You should have received a copy of the GNU Affero General 
% Public License along with this program. If not, 
% see <http://www.gnu.org/licenses/>.


%Subdivision of the initial contour into evenly distributed points
function V=subdivision(V0,k)
x=V0(:,1);
y=V0(:,2);
N=size(x,1); p=1;
for i = 1 : N-1
% subdivision between two vertices of the snake in x and y.
    long=sqrt((x(i+1)-x(i))^2+(y(i+1)-y(i))^2);
    nbre=max(1, round(long/k));
    h_x=(x(i+1)-x(i))/nbre;
    h_y=(y(i+1)-y(i))/nbre;
for j = 1 : nbre
    xi(p,1)=x(i)+j*h_x;
    yi(p,1)=y(i)+j*h_y;
    p=p+1;
end
end
% subdivision between the first and the last vertex of the snake.
long=sqrt((x(N)-x(1))^2+(y(N)-y(1))^2);
nbre=floor(long/k);
h_x=( x(1)-x(N) )/nbre;
h_y=( y(1)-y(N) )/nbre;
for j = 1 : nbre
    xi(p,1)=x(N)+j*h_x;
    yi(p,1)=y(N)+j*h_y;
    p=p+1;
end
V=[xi(:),yi(:)];
end
