% Copyright (c) 2020 
% Authors:
% F. Pierre, M. Amendola, C. Bigeard, T. Ruel
% and P.-F. Villard
% 
% This program is free software: you can redistribute it and/or 
% modify it under the terms of the GNU Affero General Public 
% License as published by the Free Software Foundation, either 
% version 3 of the License, or (at your option) any later 
% version.
% 
% This program is distributed in the hope that it will be 
% useful, but WITHOUT ANY WARRANTY; without even the implied 
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
% PURPOSE. See the GNU Affero General Public License for more 
% details.
% 
% You should have received a copy of the GNU Affero General 
% Public License along with this program. If not, 
% see <http://www.gnu.org/licenses/>.

%Matrice A computation
function A=computeA3D(adj,alpha,beta)
        
n=length(adj);

neighbors=sum(adj,2);

A2=adj;
A2 = A2 + diag(-neighbors(:));% Equation (42) in the paper

A4=A2^2;% Equation (43) in the paper

mimin=min(A2(:));
M=min(A2,[],2)/mimin;
v=1./M;
nn=length(v(:));
MM= speye(nn);
MM(1:nn+1:nn^2)=v;
A2=MM*A2;

A = -A2*alpha+A4*beta; % Equation (46) in the paper
